-- panel
local parentWidth, parentHeight = (576 * scale), (188 * scale)
local parentX, parentY = 0, (screenHeight - parentHeight - (40 * scale))

-- instance
local instance = { }

instance.visible = false

instance['render'] = function ()
    if isCursorShowing () then
        local cursor = {getCursorPosition ()}

        cursors = {
            cursor[1] * screenWidth;
            cursor[2] * screenHeight
        }
    end

    parentX = animation:get ('offset')

    dxDrawImageSpacing (parentX, parentY, parentWidth, parentHeight, respc (5), 'bg.png')
    dxDrawImage (reMap (parentX, 524), reMap (parentY, 22), respc (30), respc (30), 'trash.png', 0, 0, 0, (isMouseInPosition (reMap (parentX, 524), reMap (parentY, 22), respc (30), respc (30)) and tocolor (155, 73, 211)) or tocolor (255, 255, 255, 255 * 0.15))

    dxDrawText ('Gerenciador de Blitz', reMap (parentX, 62), reMap (parentY, 26), 0, 0, -1, 1.00, dxCreateFont ('Outfit.Medium', 18))
    dxDrawText ('Destruir tudo', reMap (parentX, 62), reMap (parentY, 26), respc (462), 0, tocolor (255, 255, 255, 255 * 0.25), 1.00, dxCreateFont ('Outfit.Medium', 18), 'right')
    dxDrawText ('Opções:', reMap (parentX, 26), reMap (parentY, 66), 0, 0, tocolor (255, 255, 255, 255 * 0.8), 1.00, dxCreateFont ('Outfit.Medium', 17))

    for i = 0, #config.options do
        local value = config.options[i + 1]
        local x = reMap (parentX, 83 + (90 * i))

        if value then
            dxDrawImage (x, reMap (parentY, 101), respc (50), respc (50), 'objects/' .. value.path, 0, 0, 0, (isMouseInPosition (x, reMap (parentY, 101), respc (50), respc (50)) and tocolor (155, 73, 211)) or tocolor (255, 255, 255, 255 * 0.25))

            if isMouseInPosition (x, reMap (parentY, 101), respc (50), respc (50)) then
                dxDrawText (value.name, cursors[1] - 20, cursors[2] - 20, 0, 0, tocolor (255, 255, 255, 255 * 0.8), 1.00, dxCreateFont ('Outfit.Medium', 14), 'left', 'top', false, false, true)
            end
        end
    end
end

instance['click'] = function (button, state)
    if not (button == 'left' and state == 'up') then
        return false
    end;

    if isMouseInPosition (reMap (parentX, 524), reMap (parentY, 22), respc (30), respc (30)) then
        triggerServerEvent ('bcr_blitz.onServerEvent', resourceRoot, localPlayer, compiler.encrypt ({
            actionName = 'destroy-all';
        }))

        return true
    end;

    for i = 0, #config.options do
        local value = config.options[i + 1]
        local x = reMap (parentX, 83 + (90 * i))

        if value and isMouseInPosition (x, reMap (parentY, 101), respc (50), respc (50)) then
            triggerServerEvent ('bcr_blitz.onServerEvent', resourceRoot, localPlayer, compiler.encrypt ({
                actionName = 'create-object';
                option = tonumber (i + 1)
            }))

            return true
        end;
    end;
end;

instance['manager'] = function (action, ...)
    if not action then
        action = 'hide'
    end;

    if not (action ~= 'show') then
        if not (not instance.visible and not animation:isRunning ('offset')) then
            return false
        end;

        instance.visible = true

        animation:exec ('offset', screenWidth, screenWidth - parentWidth - (40 * scale))

        addEventHandler ('onClientClick', root, instance.click)
        addEventHandler ('onClientRender', root, instance.render)
        return true
    end;

    if not (action ~= 'hide') then
        if not (instance.visible and not animation:isRunning ('offset')) then
            return false
        end;

        instance.visible = false

        animation:exec ('offset', animation:get ('offset'), screenWidth)

        removeEventHandler ('onClientClick', root, instance.click)

        setTimer (function ()
            removeEventHandler ('onClientRender', root, instance.render)
        end, 600, 1)
        return true
    end;

    if not (action ~= 'toggle') then
        return instance['manager'] (instance.visible and 'hide' or 'show')
    end;
end;

createEventHandler ('bcr_blitz.onClientManager', resourceRoot, instance.manager)

bindKey ('backspace', 'down', function ()
    return instance['manager'] ('hide')
end)